uses tpenv,tpcrt,tpcmd,tpstring,tppick,tpdir,tpedit,dos;
procedure display(p:pointer);inline
($5A          { POP	DX}
/$1F          { POP	DS}
/$B4/$09      { MOV	AH,09}
/$CD/$21);    { INT	21 }
type MCb=record
		   id:char;
		   owner:word;
		   size:word;
		   fill:array[1..$b]of byte;
		 end;
const tt:string[80]='File Menu Shell. Version 1.00 . Copyright(c) by Vitus B.Wagner,1992'#13#10'$';
procedure help;external;
{$L gfhelp.obj}
Procedure Error(msg:string);
begin
 Display(@tt[1]);
 if msg<>'' then Writeln('ERROR:',msg);
 Display(@help);
 halt(3)
end;
Procedure FileError(msg:string);
begin
 Display(@tt[1]);
 Writeln('ERROR:',msg);
 halt(3);
end;
procedure GetParentEnv(var E:EnvRec);
type MCb=record
		   id:char;
		   owner:word;
		   size:word;
		   fill:array[1..$b]of byte;
		 end;
var
p:^word;
q:^mcb;
begin
 p:=Ptr(MemW[PrefixSeg:$16],$16);
 p:=Ptr(p^,$2c);
 {pointer to parent PSP field, contains
 enviroment segment}
 q:=ptr(p^-1,0);
 E.EnvLen:=16*(q^.size);
 E.EnvSeg:=p^;
 E.EnvPtr:=nil;
end;
var fname,
	title,
	ename:string;
	env:envrec;
	i:byte;
	s:string;
	cmdptr:^string;
	cmdlin:string;
	SavePtr:pointer;
	Esc:boolean;
	xhi:byte;

const
	XLo:byte=5;
	yLo:byte=10;
	Yhi:byte=22;
	Edit:boolean=True;
	BW:Boolean=false;
	BriefName:boolean=false;
	SupressExt:boolean=false;
	PickCols:byte=4;
	Colors:array[boolean]of PickColorArray=(($1f,$1f,$3f,$30,$1f,$30),($7,$7,$70,$70,$7,$70));
function ExtractNumber:integer;
var a:longint;
begin
 if not Str2Long(copy(s,pos('=',s)+1,255),a) then
  Error('Invalid number');
 ExtractNumber:=a
end;
begin
 {Parse Command line}
 cmdptr:=ptr(PrefixSeg,$80);
 cmdlin:=trim(cmdptr^);
 if (cmdlin='/?')or(cmdlin='') then
  Error('');

 if cmdlin[1]='"' then
  begin
   i:=pos('"',copy(cmdlin,2,255));
   if i=0 then Error('Variable name missing');
   title:=copy(cmdlin,2,i-1);
   cmdlin:=trim(copy(cmdlin,i+2,255));
  end
   else title:='';
   i:=pos(' ',cmdlin);
   if i=0 then error('Search pattern missing');
   ename:=copy(cmdlin,1,i-1);
   cmdlin:=trim(copy(cmdlin,i+1,255));
   i:=pos(' ',cmdlin);
   if i=0 then i:=pos('/',cmdlin);
   if i=0 then i:=length(cmdlin);
   fname:=copy(cmdlin,1,i);
   cmdlin:=StUpCase(trim(copy(cmdlin,i+1,255)));
   For i:=1 to WordCount(cmdlin,[' ',',','/']) do
	begin
	 s:=ExtractWord(i,cmdlin,[' ',',','/']);
	 if s='BW' then bw:=true
	  else
	 if s='NOEDIT' then Edit:=false
	  else
	 if copy(s,1,2)='X=' then Xlo:=ExtractNumber
	  else
	 if copy(s,1,3)='R0=' then Ylo:=ExtractNumber
	  else
	 if copy (s,1,3)='RE=' then yhi:=ExtractNumber
	  else
	  if s='B' then BriefName:=True
	 else
	 if s='E' then SupressExt:=True
	 else
	if copy(s,1,4)='COL='then PickCols:=ExtractNumber
	 else
	 Error('Invalid command line option');
	end;
  {Edit Pattern}
   framechars:='Ȼͺ';
  if edit then
  begin
   xhi:=xlo+35;
   if SaveWindow(Xlo,ylo,xhi,ylo+2,true,SavePtr) then;
   FrameWindow(xlo,ylo,xhi,ylo+2,Colors[bw,FrameAttr],Colors[bw,HeaderAttr],title);
   ReadString('',ylo+1,xlo+1,xhi-xlo-2,
   Colors[BW,WindowAttr],Colors[BW,WindowAttr],Colors[BW,WindowAttr],
   Esc,Fname);
   RestoreWindow(Xlo,ylo,xhi,ylo+2,true,SavePtr);
   if esc then halt(2);
  end;
  i:=GetFileName(Fname, $37 ,Xlo,Ylo,Yhi,PickCols,Colors[bw],fname);
  case i of
  0:;
  1:FileError('Path not found');
  2:FileError('No Matching Files');
  3:;
  4:FileError('Insufficient memory');
  5:Error('Illegal size of menu');
  else
   FileError('Error in file system')
  end;
  if PickChar=#27 then
	Halt(2);
  if briefname then
	fname:=JustFileName(fname);
  if SupressExt then
   begin
	xhi:=pos('.',fname)-1;
	if xhi>0 then  fname:=copy(fname,1,xhi);
   end;
  GetParentEnv(Env);
  if not SetEnvStr(Env,Ename,Fname) then FileError('Out of Enviroment space');
  halt(i div 3);
 end.